<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '~/mixins';

export default Vue.extend({
  name: 'SurveyAccordion',
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Object,
      required: true,
      default: () => {},
    },
    isDesktopAccordion: {
      type: Boolean,
      required: false,
      default: false,
    },
    openByDefault: {
      type: Boolean,
      required: false,
      default: false,
    },
    backgroundColor: {
      type: String,
      required: false,
      default: '#ffffff',
    },
    mobileOnly: {
      // should only be needed for the Demographics section
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    return {
      isExpanded: this.openByDefault,
    };
  },
  computed: {
    elementId() {
      return `${this.data.title}-${Math.random()}`;
    },
  },
});
</script>

<template>
  <div
    :class="`survey-accordion ${mobileOnly ? 'mobile-only' : ''}`"
    :style="`background-color: ${backgroundColor};`"
  >
    <div v-if="isMobile || isDesktopAccordion">
      <button
        :id="`${elementId}-control`"
        :aria-controls="`${elementId}-content`"
        :class="`header ${isExpanded ? 'expanded' : ''}`"
        :aria-expanded="isExpanded"
        @click="isExpanded = !isExpanded"
      >
        {{ data.title }}
        <SlpIcon name="chevron-lg-down" variant="product" hex-color="#232150" />
      </button>
      <div
        v-show="isExpanded"
        :id="data.title"
        class="content"
        role="region"
        :aria-labelledby="`${elementId}-control`"
      >
        <div v-if="data.text" class="text" v-html="$md.render(data.text)"></div>
        <slot></slot>
      </div>
    </div>
    <div v-else>
      <div class="header">
        <p>{{ data.title }}</p>
      </div>
      <div class="content">
        <div v-if="data.text" class="text" v-html="$md.render(data.text)"></div>
        <slot></slot>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.survey-accordion {
  color: #232150;
  border-radius: 8px;
  box-shadow: 0px 1px 4px 0px rgba(0, 0, 0, 0.1);
  @media (max-width: $breakpoint-md) {
    padding: 16px;
    overflow-x: scroll;
  }

  &.mobile-only {
    @media (min-width: $breakpoint-md) {
      display: none;
    }
  }

  .header {
    display: flex;
    align-items: center;
    color: #232150;
    justify-content: space-between;
    font-size: 18px;
    font-weight: 700;
    outline: none;
    border: none;
    width: 100%;
    text-align: left;
    padding: 24px;

    &:focus-visible {
      text-decoration: underline;
      text-decoration-color: #232150;
    }

    @media (max-width: $breakpoint-md) {
      padding: 0;
      font-size: 14px;
    }

    &.expanded .slp-icon {
      transform: rotate(180deg);
    }

    .slp-icon {
      transition: transform 0.2s ease-in-out;
    }

    &:is(button) {
      cursor: pointer;
    }
  }

  .content {
    font-size: 14px;
    line-height: 22px;
    padding: 0px 24px 24px 24px;

    @media (max-width: $breakpoint-md) {
      padding: 24px 0 0 0;
    }

    .text:deep {
      p {
        display: block;
        margin-bottom: 16px;

        &:last-of-type {
          margin-bottom: 0;
        }
      }

      ul,
      ol {
        padding-left: 1.5rem;
      }

      li {
        list-style-type: disc;
        margin-bottom: 8px;
      }

      h2,
      h3 {
        font-size: 14px;
        font-style: normal;
        font-weight: 600;
        line-height: 22px;
      }
    }
  }
}
</style>
